%%
% This script describes the processing completed by Mike Berks to analyze
% the Milano-Primovist dataset, comprising 10 patients with HCC tumours
% that underwent DCE-MRI of the liver using the active contrast agent
% Gadoxetate (commercial name Primovist)
%
% The data is already converted from DICOM to analyze format and sorted
% into folder on the QUBI server as per standard QBI dataset. A copy of the
% data has been transferred to Mike Berks' local machine
%
% Complete steps for processing the data:
% 1)) Create T1 map from variable flip angles
%
% 2) Detect aorta and compute AIFs
%
% 3) Create temporal means of DCE sequence at key time-points, upload the
% data to QUBI server for radiolgist annotation of ROIs
%
% 4) Motion correct the DCE volumes...
%  i) Use ANTs to compute local transformation between neighbouring
%  temporal images
%  ii) Compute motion model from resulting deformation fields
%  iii) Register to dynamic mean using motion model
%
%
% 5) Fit DCE models to motion corrected sequence
%
% 6) Perform post-fit model selection and parameter analysis
%
%% 
%--------------------------------------------------------------------------
%%
study_dir = 'C:/isbe/qbi/data/milano_primovist/';

%% 1) Create T1 map from variable flip angles
milano_batch_fun(@milano_T1_map, study_dir, 1:10, 1,...
    'make_FA_means', 1,...
    'do_T1_map', 1,...
    'do_T1_error', 0,...
    'do_FA_std', 0,...
    'FA_mean_dir', 'FA_means',...
    'T1_dir', 'mdm_analysis_T1',...
    'reg_sfx', [],...
    'view_slice', 24,...
    'overwrite', 1,...
    'dummy_run', 0);

%% 2) Detect aorta and compute AIFs
milano_batch_fun(@milano_aif, study_dir, 1:10, 1);

%% 3) Create temporal means of DCE sequence at key time-points, upload the
% data to QUBI server for radiolgist annotation of ROIs
milano_batch_fun(@milano_make_postcon_means, study_dir, 1:10, 1);
% ii) Make subset masks from
milano_batch_fun(@milano_make_subset_masks, study_dir, 1:10, 1);
%% 4) Motion correct the cropped DCE volumes...
%  i) Use ANTs to compute local transformation between neighbouring
%  temporal images
%  ii) Compute motion model from resulting deformation fields
%  iii) Register to dynamic mean using motion model
% Note the initial ANTs fixed and local registrations are computed on the
% CSF, called from a python script
milano_batch_fun(@dce_motion_model_registration, study_dir, 1:10, 1,...
    'results_root', 'Q:/data/MB/',...
    'n_vols', 100,...
    'load_vols', 2,...
    'do_fixed', 1,...
    'do_local_transforms', 1,...
    'do_constrained_pca', 1,...
    'do_apply_pca', 1,...
    'do_write_pca_dyn', 1,...
    'do_write_fixed_dyn', 1,...
    'do_T1_FA_vols', 0,...
    'do_T1_FA_means', 0,...
    'dynamic_dir', 'dynamic_cropped',...
    'scale', 2,...
    'pca_model_vols', 20:96,...
    'pca_thresh', 0.95,...
    'num_pca_modes', 10,...
    'max_iter', 100,...
    'view_slice', [],...
    'ants_overwrite', 0,...
    'save_figs', 1,...
    'debug', 1);

%% 7) Make dynamic concentration volumes
milano_batch_fun(@milano_make_dyn_conc, study_dir, 1:10, 1,...
    'do_reg', 0,...
    'dummy_run', 0);
%%
milano_batch_fun(@milano_make_dyn_conc, study_dir, 1:10, 1,...
    'do_reg', 1,...
    'dummy_run', 0);

%% 8) Fit DCE models to motion corrected sequence in Madym
% We fit the following (motion ocrrected unless otherwise stated):
%% iii)
% Compute temporal residuals from initial fit
analysis_dirs = {
    'mdm_analysis_ants_DIBEM_f137'
    'mdm_analysis_ants_DIBEM_f37'
    'mdm_analysis_ants_DIBEM_f7'};
milano_batch_fun(@make_temporal_residuals, study_dir, 1:10, 1,...
    'dyn_conc_dir', 'dynamic_conc_reg_ants',...
    'dynamic_dir', 'dynamic_reg_ants',...
    'n_vols', 100,...
    'analysis_dirs', analysis_dirs,...
    'roi_mask_path', 'analysis_masks/liver_mask.hdr',...
    'save_dir', 'dynamic_reg_ants',...
    'update_xtr_files', 0,...
    'plot', 1);


%% 9) Perform post-fit model selection and parameter analysis
experiment_info = {
    '_ants', '_ants', '', 100};

for i_exp = 1%1:length(experiment_info)
    model_base = ['mdm_analysis' experiment_info{i_exp,1} '_DIBEM_'];
    roi = ['analysis_masks/liver_mask' experiment_info{i_exp,3} '.hdr'];
    results_dir = ['results/mdm_summary' experiment_info{i_exp,1}];
    
    milano_batch_fun(@milano_postfit_analysis, study_dir);
end

%%
milano_batch_fun(@milano_make_figures, study_dir, 1:10, 1,...
    'results_dir', 'results/mdm_summary_ants',...
    'dyn_dir', 'dynamic_reg_ants',...
    'n_vols', 100,...
    'do_param_map_figs', 0,...
    'do_aic_class_figs', 1,...
    'do_dyn_figs', 1,...
    'do_tse_figs', 0,...
    'display_figs', 0,...
    'save_figs', 1,...
    'mean_start', 40,...
    'tse_scaling', 0.01);

%% Appendix: take back-up of data to dropbox for Geoff
backup_dir = ['C:/Users\momeemb2/OneDrive - The University of Manchester/'...
    'QBI/milano_primovist/'];

milano_batch_fun(@milano_backup_data, study_dir, 1:10, 1,...
    'backup_dir', backup_dir, ...
    'do_dynamic_sig', 0,...
    'do_dynamic_sig_reg', 0,...
    'do_temporal_means', 0,...
    'do_analysis_masks', 1,...
    'do_VFA_vols', 0,...
    'do_VFA_vols_reg', 0,...
    'do_T1_analysis', 1,...
    'do_T1_analysis_reg', 1,...
    'do_dynamic_conc', 1,...
    'do_dynamic_conc_reg', 1,...
    'do_tk_model_output', 0,...
    'dummy', 0);

%% Take back-up of data to dropbox for Geoff
backup_dir = ['C:/Users\momeemb2/OneDrive - The University of Manchester/'...
    'QBI/milano_primovist/'];

milano_batch_fun(@milano_backup_data, study_dir, 1:10, 1,...
    'backup_dir', backup_dir, ...
    'do_dynamic_sig', 0,...
    'do_dynamic_sig_reg', 0,...
    'do_temporal_means', 0,...
    'do_analysis_masks', 0,...
    'do_VFA_vols', 0,...
    'do_VFA_vols_reg', 0,...
    'do_T1_analysis', 0,...
    'do_T1_analysis_reg', 0,...
    'do_dynamic_conc', 0,...
    'do_dynamic_conc_reg', 0,...
    'do_tk_model_output', 1,...
    'dummy', 0);
